//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * サウンドリーダヘッダ
 * @author Junpee
 */

#ifndef SOUND_READER_H_
#define SOUND_READER_H_

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * サウンドリーダ
 */
class SoundReader{
public:
	/**
	 * コンストラクタ
	 */
	SoundReader(){}

	/**
	 * デストラクタ
	 */
	virtual ~SoundReader(){}

	//--------------------------------------------------------------------------
	/**
	 * サイズの取得
	 * @return サイズ
	 */
	virtual u_int getSize() const = 0;

	/**
	 * サンプル数の取得
	 * @return サンプル数
	 */
	virtual int getSample() const = 0;

	/**
	 * チャンネル数の取得
	 * @return チャンネル数
	 */
	virtual int getChannel() const = 0;

	/**
	 * ビット数の取得
	 * @return ビット数
	 */
	virtual int getBit() const = 0;

	/**
	 * コメントの取得
	 * @return コメント
	 */
	virtual const String& getComment() = 0;

	//--------------------------------------------------------------------------
	/**
	 * 長さの取得
	 * @return 秒単位の長さ
	 */
	virtual float getLength() const{ return byteToTime(getSize()); }

	/**
	 * 1秒のバイト数取得
	 * @return 1秒のバイト数
	 */
	virtual int getOneSecondBytes() const{
		return (getSample() * (getChannel() * getBit() / 8));
	}

	/**
	 * バイト数から時間への変換
	 * @param byte バイト数
	 * @return 秒単位の時間
	 */
	virtual float byteToTime(u_int byte) const{
		Assert(byte < getSize());
		return (float)byte / (float)getOneSecondBytes();
	}

	/**
	 * 時間からバイト数への変換
	 * @return time 秒単位の時間
	 * @return バイト数
	 */
	virtual u_int timeToByte(float time) const{
		Assert((time >= 0.f) && (time < getLength()));
		return (u_int)(time * getOneSecondBytes());
	}

	//--------------------------------------------------------------------------
	/**
	 * 位置の設定
	 * @param cursor 設定する位置
	 */
	virtual void setCursor(u_int cursor) = 0;

	/**
	 * 位置の取得
	 * @return 位置
	 */
	virtual u_int getCursor() = 0;

	//--------------------------------------------------------------------------
	/**
	 * ヘッダ読み込み
	 * @return 成功すればtrue
	 */
	virtual bool readHeader() = 0;

	/**
	 * 読み込み
	 * @param buffer 読み込みバッファ
	 * @param size 読み込みサイズ
	 * @return 読み込んだサイズ。終端なら0、失敗すれば-1
	 */
	virtual int read(void* buffer, u_int size) = 0;

private:
	// コピーコンストラクタの隠蔽
	SoundReader(const SoundReader& copy);

	// 代入コピーの隠蔽
	void operator =(const SoundReader& copy);

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of SOUND_READER_H_
//------------------------------------------------------------------------------

